﻿package {

	import starling.core.Starling;
	import starling.display.MovieClip;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;
	import starling.utils.rad2deg;

	import flash.display.Bitmap;

	/**
	 * @author Aymeric
	 */
	public class StarlingTest extends Sprite {

		private var _patches:Vector.<MovieClip>;
		private var _mc:MovieClip;

		[Embed(source="../assets/patch.xml", mimeType="application/octet-stream")]
		public static const SPRITESHEETXML:Class;

		[Embed(source="../assets/patch.png")]
		private static const _SPRITESHEET:Class;

		public function StarlingTest() {

			addEventListener(Event.ADDED_TO_STAGE, _init);
		}

		private function _init(evt:Event):void {

			removeEventListener(Event.ADDED_TO_STAGE, _init);

			var bitmap:Bitmap = new _SPRITESHEET();
			var texture:Texture = Texture.fromBitmap(bitmap);
			var xml:XML = XML(new SPRITESHEETXML());
			var sTextureAtlas:TextureAtlas = new TextureAtlas(texture, xml);
			var frames:Vector.<Texture> = sTextureAtlas.getTextures("patch_");

			_patches = new Vector.<MovieClip>();

			for (var i:uint = 0; i < 300; ++i) {
				_mc = new MovieClip(frames, 60);
				addChild(_mc);

				if (Math.random() > 0.5)
					_mc.scaleX = -1;

				_mc.x = stage.stageWidth * Math.random();
				_mc.y = stage.stageHeight * Math.random();

				// Keep the Stats visible
				if (_mc.x < 150 && _mc.y < 150) {
					_mc.x += 150;
					_mc.y += 150;
				}

				_patches.push(_mc);
				Starling.juggler.add(_mc);
			}

			addEventListener(Event.ENTER_FRAME, _ef);
		}

		private function _ef(evt:Event):void {

			for each (var patch:MovieClip in _patches) {
				patch.rotation += rad2deg(Math.random());
				patch.alpha = Math.random();
			}
		}
	}
}
