package {

	import citrus.core.State;
	import citrus.math.MathUtils;
	import citrus.objects.Box2DPhysicsObject;
	import citrus.objects.platformer.box2d.Platform;
	import citrus.physics.box2d.Box2D;

	/**
	 * @author Aymeric
	 */
	public class StateTest extends State {
		
		[Embed(source="../assets/crate.png")]
		private static const _CRATE:Class;

		public function StateTest() {
			super();
		}

		override public function initialize():void {
			super.initialize();
			
			var nape:Box2D = new Box2D("nape");
			//nape.visible = true;
			add(nape);
			
			add(new Platform("bot", {x:stage.stageWidth / 2, y:stage.stageHeight, width:stage.stageWidth}));
			add(new Platform("left", {y:stage.stageHeight / 2 , height:stage.stageHeight}));
			add(new Platform("right", {x:stage.stageWidth, y:stage.stageHeight / 2 , height:stage.stageHeight}));
			
			var crate:Box2DPhysicsObject;
			for (var i:uint = 0; i < 10; ++i) {
				
				crate = new Box2DPhysicsObject("crate" + i, {x: MathUtils.randomInt(30, stage.stageWidth - 60), view:new _CRATE()});
				add(crate);
			}
		}

	}
}
